case-studies/dukes-forest/dukes-store/src/main/java/com/forest/ejb/OrderBean.java
/**
 * Copyright (c) 2014 Oracle and/or its affiliates. All rights reserved.
 *
 * You may not modify, use, reproduce, or distribute this software except in
 * compliance with  the terms of the License at:
 * https://github.com/javaee/tutorial-examples/LICENSE.txt
 */
package com.forest.ejb;

import com.forest.entity.CustomerOrder;
import com.forest.entity.OrderStatus;
import java.io.Serializable;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.ws.rs.*;

/**
 * OrderBean is an EJB exposed as RESTful service Provides methods to manipulate
 * order status and query orders based on specific status.
 *
 * @author markito
 */
@Stateless
@Path("/orders")
public class OrderBean extends AbstractFacade<CustomerOrder> implements Serializable {

    private static final Logger logger = 
            Logger.getLogger(ShoppingCart.class.getCanonicalName());
    private static final long serialVersionUID = -2407971550575800416L;
    @PersistenceContext(unitName = "forestPU")
    private EntityManager em;
    CustomerOrder order;
    @EJB
    OrderStatusBean statusBean;

    public OrderBean() {
        super(CustomerOrder.class);
    }

    /**
     * **************************************************************************
     * Business methods
     * ***************************************************************************
     */
    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public List<CustomerOrder> getOrderByCustomerId(Integer id) {
        Query createNamedQuery = getEntityManager().createNamedQuery("CustomerOrder.findByCustomerId");

        createNamedQuery.setParameter("id", id);

        return createNamedQuery.getResultList();
    }
    
    public CustomerOrder getOrderById(Integer id) {
        Query createNamedQuery = getEntityManager().createNamedQuery("CustomerOrder.findById");
        createNamedQuery.setParameter("id", id);
        return (CustomerOrder) createNamedQuery.getSingleResult();
    }
  
    @GET
    @Produces({"application/xml", "application/json"})
    public List<CustomerOrder> getOrderByStatus(@QueryParam("status") int status) {

        Query createNamedQuery = getEntityManager().createNamedQuery("CustomerOrder.findByStatus");

        OrderStatus result = statusBean.find(status);

        createNamedQuery.setParameter("status", result.getStatus());
        List<CustomerOrder> orders = createNamedQuery.getResultList();

        return orders;
    }

    @PUT
    @Path("{orderId}")
    @Produces({"application/xml", "application/json"})
    public void setOrderStatus(@PathParam("orderId") int orderId, String newStatus) { 
        
        logger.log(Level.INFO, "Order id:{0} - Status:{1}", new Object[]{orderId, newStatus});

        try {
            order = this.find(orderId);

            if (order != null) {
                logger.log(Level.FINEST, "Updating order {0} status to {1}", new Object[]{order.getId(), newStatus});

                OrderStatus oStatus = statusBean.find(new Integer(newStatus));
                order.setOrderStatus(oStatus);

                em.merge(order);

                logger.info("Order Updated!");
            }

        } catch (Exception ex) {

            logger.log(Level.SEVERE, ex.getMessage());
        }

    }
    
     /**
     * ***************************************************************************
     * Status orders mapped to ENUM
     */
    public enum Status {

        PENDING_PAYMENT(2),
        READY_TO_SHIP(3),
        SHIPPED(4),
        CANCELLED_PAYMENT(5),
        CANCELLED_MANUAL(6);
        private int status;

        private Status(int pStatus) {
            status = pStatus;
        }

        public int getStatus() {
            return status;
        }
    }
}

case-studies/dukes-forest/dukes-store/src/main/java/com/forest/web/GroupsController.java
/**
 * Copyright (c) 2014 Oracle and/or its affiliates. All rights reserved.
 *
 * You may not modify, use, reproduce, or distribute this software except in
 * compliance with  the terms of the License at:
 * https://github.com/javaee/tutorial-examples/LICENSE.txt
 */
package com.forest.web;

import com.forest.ejb.GroupsBean;
import com.forest.entity.Groups;
import com.forest.web.util.AbstractPaginationHelper;
import com.forest.web.util.JsfUtil;
import com.forest.web.util.PageNavigation;
import java.io.Serializable;
import java.util.ResourceBundle;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.faces.model.SelectItem;
import javax.inject.Named;

@Named(value = "groupsController")
@SessionScoped
public class GroupsController implements Serializable {

    private static final String BUNDLE = "bundles.Bundle";
    private static final long serialVersionUID = 915049365977089806L;

    private Groups current;
    private DataModel items = null;
    @EJB
    private com.forest.ejb.GroupsBean ejbFacade;
    private AbstractPaginationHelper pagination;
    private int selectedItemIndex;

    public GroupsController() {
    }

    public Groups getSelected() {
        if (current == null) {
            current = new Groups();
            selectedItemIndex = -1;
        }
        return current;
    }

    private GroupsBean getFacade() {
        return ejbFacade;
    }

    public AbstractPaginationHelper getPagination() {
        if (pagination == null) {
            pagination = new AbstractPaginationHelper(10) {

                @Override
                public int getItemsCount() {
                    return getFacade().count();
                }

                @Override
                public DataModel createPageDataModel() {
                    return new ListDataModel(getFacade().findRange(new int[]{getPageFirstItem(), 
                        getPageFirstItem() + getPageSize()}));
                }
            };
        }
        return pagination;
    }

    public PageNavigation prepareList() {
        recreateModel();
        return PageNavigation.LIST;
    }

    public PageNavigation prepareView() {
        current = (Groups) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return PageNavigation.VIEW;
    }

    public PageNavigation prepareCreate() {
        current = new Groups();
        selectedItemIndex = -1;
        return PageNavigation.CREATE;
    }

    public PageNavigation create() {
        try {
            getFacade().create(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle(BUNDLE).getString("GroupsCreated"));
            return prepareCreate();
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle(BUNDLE).getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public PageNavigation prepareEdit() {
        current = (Groups) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return PageNavigation.EDIT;
    }

    public PageNavigation update() {
        try {
            getFacade().edit(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle(BUNDLE).getString("GroupsUpdated"));
            return PageNavigation.VIEW;
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle(BUNDLE).getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public PageNavigation destroy() {
        current = (Groups) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        performDestroy();
        recreateModel();
        return PageNavigation.LIST;
    }

    public PageNavigation destroyAndView() {
        performDestroy();
        recreateModel();
        updateCurrentItem();
        if (selectedItemIndex >= 0) {
            return PageNavigation.VIEW;
        } else {
            // all items were removed - go back to list
            recreateModel();
            return PageNavigation.LIST;
        }
    }

    private void performDestroy() {
        try {
            getFacade().remove(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle(BUNDLE).getString("GroupsDeleted"));
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle(BUNDLE).getString("PersistenceErrorOccured"));
        }
    }

    private void updateCurrentItem() {
        int count = getFacade().count();
        if (selectedItemIndex >= count) {
            // selected index cannot be bigger than number of items:
            selectedItemIndex = count - 1;
            // go to previous page if last page disappeared:
            if (pagination.getPageFirstItem() >= count) {
                pagination.previousPage();
            }
        }
        if (selectedItemIndex >= 0) {
            current = getFacade().findRange(new int[]{selectedItemIndex, selectedItemIndex + 1}).get(0);
        }
    }

    public DataModel getItems() {
        if (items == null) {
            items = getPagination().createPageDataModel();
        }
        return items;
    }

    private void recreateModel() {
        items = null;
    }

    public PageNavigation next() {
        getPagination().nextPage();
        recreateModel();
        return PageNavigation.LIST;
    }

    public PageNavigation previous() {
        getPagination().previousPage();
        recreateModel();
        return PageNavigation.LIST;
    }

    public SelectItem[] getItemsAvailableSelectMany() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), false);
    }

    public SelectItem[] getItemsAvailableSelectOne() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), true);
    }

    @FacesConverter(forClass = Groups.class)
    public static class GroupsControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            GroupsController controller = (GroupsController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "groupsController");
            return controller.ejbFacade.find(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof Groups) {
                Groups o = (Groups) object;
                return getStringKey(o.getId());
            } else {
                throw new IllegalArgumentException("object " + object + " is of type " + object.getClass().getName() + "; expected type: " + GroupsController.class.getName());
            }
        }
    }
}

case-studies/dukes-forest/dukes-store/src/main/webapp/order/Create.xhtml
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!--

    Copyright (c) 2014 Oracle and/or its affiliates. All rights reserved.

    You may not modify, use, reproduce, or distribute this software except in
    compliance with  the terms of the License at:
    https://github.com/javaee/tutorial-examples/LICENSE.txt

-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.CreateCustomerOrderTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.CreateCustomerOrderLabel_id}" for="id" />
                    <h:inputText id="id" value="#{customerOrderController.selected.id}" title="#{bundle.CreateCustomerOrderTitle_id}" required="true" requiredMessage="#{bundle.CreateCustomerOrderRequiredMessage_id}"/>
                    <h:outputLabel value="#{bundle.CreateCustomerOrderLabel_amount}" for="amount" />
                    <h:inputText id="amount" value="#{customerOrderController.selected.amount}" title="#{bundle.CreateCustomerOrderTitle_amount}" required="true" requiredMessage="#{bundle.CreateCustomerOrderRequiredMessage_amount}"/>
                    <h:outputLabel value="#{bundle.CreateCustomerOrderLabel_dateCreated}" for="dateCreated" />
                    <h:inputText id="dateCreated" value="#{customerOrderController.selected.dateCreated}" title="#{bundle.CreateCustomerOrderTitle_dateCreated}" required="true" requiredMessage="#{bundle.CreateCustomerOrderRequiredMessage_dateCreated}">
                        <f:convertDateTime pattern="MM/dd/yyyy HH:mm:ss" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.CreateCustomerOrderLabel_orderStatus}" for="orderStatus" />
                    <h:selectOneMenu id="orderStatus" value="#{customerOrderController.selected.orderStatus}" title="#{bundle.CreateCustomerOrderTitle_orderStatus}" required="true" requiredMessage="#{bundle.CreateCustomerOrderRequiredMessage_orderStatus}">
                        <f:selectItems value="#{orderStatusController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                    <h:outputLabel value="#{bundle.CreateCustomerOrderLabel_customer}" for="customer" />
                    <h:selectOneMenu id="customer" value="#{customerOrderController.selected.customer}" title="#{bundle.CreateCustomerOrderTitle_customer}" required="true" requiredMessage="#{bundle.CreateCustomerOrderRequiredMessage_customer}">
                        <f:selectItems value="#{customerController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{customerOrderController.create}" value="#{bundle.CreateCustomerOrderSaveLink}" />
                <br />
                <br />
                <h:commandLink action="#{customerOrderController.prepareList}" value="#{bundle.CreateCustomerOrderShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:commandLink value="#{bundle.CreateCustomerOrderIndexLink}" action="/index" immediate="true" />
            </h:form>
        </ui:define>
    </ui:composition>

</html>

case-studies/dukes-forest/dukes-store/src/main/webapp/order/List.xhtml
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!--

    Copyright (c) 2014 Oracle and/or its affiliates. All rights reserved.

    You may not modify, use, reproduce, or distribute this software except in
    compliance with  the terms of the License at:
    https://github.com/javaee/tutorial-examples/LICENSE.txt

-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ListCustomerOrderTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
        <h:form styleClass="jsfcrud_list_form">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:outputText escape="false" value="#{bundle.ListCustomerOrderEmpty}" rendered="#{customerOrderController.items.rowCount == 0}"/>
            <h:panelGroup rendered="#{customerOrderController.items.rowCount > 0}">
                <h:outputText value="#{customerOrderController.pagination.pageFirstItem + 1}..#{customerOrderController.pagination.pageLastItem + 1}/#{customerOrderController.pagination.itemsCount}"/>&nbsp;
                <h:commandLink action="#{customerOrderController.previous}" value="#{bundle.Previous} #{customerOrderController.pagination.pageSize}" rendered="#{customerOrderController.pagination.hasPreviousPage}"/>&nbsp;
                <h:commandLink action="#{customerOrderController.next}" value="#{bundle.Next} #{customerOrderController.pagination.pageSize}" rendered="#{customerOrderController.pagination.hasNextPage}"/>&nbsp;
                <h:dataTable value="#{customerOrderController.items}" var="item" border="0" cellpadding="2" cellspacing="0" rowClasses="jsfcrud_odd_row,jsfcrud_even_row" rules="all" style="border:solid 1px">
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_id}"/>
                        </f:facet>
                        <h:outputText value="#{item.id}"/>
                    </h:column>
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_amount}"/>
                        </f:facet>
                        <h:outputText value="#{item.amount}"/>
                    </h:column>
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_dateCreated}"/>
                        </f:facet>
                        <h:outputText value="#{item.dateCreated}">
                            <f:convertDateTime pattern="MM/dd/yyyy HH:mm:ss" />
                        </h:outputText>
                    </h:column>
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_orderStatus}"/>
                        </f:facet>
                        <h:outputText value="#{item.orderStatus}"/>
                    </h:column>
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_customer}"/>
                        </f:facet>
                        <h:outputText value="#{item.customer}"/>
                    </h:column>
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="&nbsp;"/>
                        </f:facet>
                        <h:commandLink action="#{customerOrderController.prepareView}" value="#{bundle.ListCustomerOrderViewLink}"/>
                        <h:outputText value=" "/>
                        <h:commandLink action="#{customerOrderController.prepareEdit}" value="#{bundle.ListCustomerOrderEditLink}"/>
                        <h:outputText value=" "/>
                        <h:commandLink action="#{customerOrderController.destroy}" value="#{bundle.ListCustomerOrderDestroyLink}"/>
                    </h:column>
                </h:dataTable>
            </h:panelGroup>
            <br />
            <h:commandLink action="#{customerOrderController.prepareCreate}" value="#{bundle.ListCustomerOrderCreateLink}"/>
            <br />
            <br />
            <h:commandLink value="#{bundle.ListCustomerOrderIndexLink}" action="/index" immediate="true" />
        </h:form>
        </ui:define>
    </ui:composition>

</html>

case-studies/dukes-forest/dukes-store/src/main/webapp/order/MyOrders.xhtml
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!--

    Copyright (c) 2014 Oracle and/or its affiliates. All rights reserved.

    You may not modify, use, reproduce, or distribute this software except in
    compliance with  the terms of the License at:
    https://github.com/javaee/tutorial-examples/LICENSE.txt

-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ViewCustomerOrderTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:form> 
                <h:outputText rendered="#{userController.authenticatedUser == null}" value="#{bundle.NoOrdersForUnauthenticated}" ></h:outputText>
                <h:dataTable value="#{customerOrderController.myOrders}" var="item" rowClasses="firstRow, secondRow" rendered="#{userController.authenticatedUser != null}" >
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_id}"/>
                        </f:facet>
                        <h:commandLink value="#{item.id}" onclick="open_win('#{request.contextPath}/orderDetail/View_popup.xhtml?orderId=#{item.id}')">
                        </h:commandLink>
                    </h:column>
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_orderStatus}"/>
                        </f:facet>

                            <h:outputText value="#{item.orderStatus.status}"/>
                    </h:column>

                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="Description"/>
                        </f:facet>
                            <h:outputText value="#{item.orderStatus.description}"/>
                    </h:column>
                    
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_amount}"/>
                        </f:facet>
                        <h:outputText value="#{item.amount}">
                            <f:convertNumber currencySymbol="$" type="currency"/>
                        </h:outputText>
                    </h:column>
                    <h:column>
                        <f:facet name="header">
                            <h:outputText value="#{bundle.ListCustomerOrderTitle_dateCreated}"/>
                        </f:facet>
                        <h:outputText value="#{item.dateCreated}">
                            <f:convertDateTime pattern="MM/dd/yyyy HH:mm:ss" />
                        </h:outputText>
                    </h:column>
                </h:dataTable>
            </h:form>
        </ui:define>
    </ui:composition>
</html>

case-studies/dukes-forest/dukes-store/src/main/webapp/order/View.xhtml
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!--

    Copyright (c) 2014 Oracle and/or its affiliates. All rights reserved.

    You may not modify, use, reproduce, or distribute this software except in
    compliance with  the terms of the License at:
    https://github.com/javaee/tutorial-examples/LICENSE.txt

-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ViewCustomerOrderTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputText value="#{bundle.ViewCustomerOrderLabel_id}"/>
                    <h:outputText value="#{customerOrderController.selected.id}" title="#{bundle.ViewCustomerOrderTitle_id}"/>
                    <h:outputText value="#{bundle.ViewCustomerOrderLabel_amount}"/>
                    <h:outputText value="#{customerOrderController.selected.amount}" title="#{bundle.ViewCustomerOrderTitle_amount}"/>
                    <h:outputText value="#{bundle.ViewCustomerOrderLabel_dateCreated}"/>
                    <h:outputText value="#{customerOrderController.selected.dateCreated}" title="#{bundle.ViewCustomerOrderTitle_dateCreated}">
                        <f:convertDateTime pattern="MM/dd/yyyy HH:mm:ss" />
                    </h:outputText>
                    <h:outputText value="#{bundle.ViewCustomerOrderLabel_orderStatus}"/>
                    <h:outputText value="#{customerOrderController.selected.orderStatus}" title="#{bundle.ViewCustomerOrderTitle_orderStatus}"/>
                    <h:outputText value="#{bundle.ViewCustomerOrderLabel_customer}"/>
                    <h:outputText value="#{customerOrderController.selected.customer}" title="#{bundle.ViewCustomerOrderTitle_customer}"/>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{customerOrderController.destroyAndView}" value="#{bundle.ViewCustomerOrderDestroyLink}"/>
                <br />
                <br />
                <h:commandLink action="Edit" value="#{bundle.ViewCustomerOrderEditLink}"/>
                <br />
                <h:commandLink action="#{customerOrderController.prepareCreate}" value="#{bundle.ViewCustomerOrderCreateLink}" />
                <br />
                <h:commandLink action="#{customerOrderController.prepareList}" value="#{bundle.ViewCustomerOrderShowAllLink}"/>
                <br />
                <br />
                <h:commandLink value="#{bundle.ViewCustomerOrderIndexLink}" action="/index" immediate="true" />

            </h:form>
        </ui:define>
    </ui:composition>

</html>